do
	local InitGlobalsOrigin = InitGlobals
	function InitGlobals()
		InitGlobalsOrigin()

		local status, err = pcall(function() -- check errors	
			-- "Global" values
			local max_players = GetBJMaxPlayers()
			-- Spell Ids
			-- Mental Erosion
			local spell_me = FourCC('ATme')
			local spell_md = FourCC('ATd1')
			-- local spellmb = FourCC('BTme') - prevent attack to unit with Mental Erosion buff
			local me_effect_slam = "Abilities\\Spells\\Other\\HowlOfTerror\\HowlCaster.mdl"
			-- Burning Chains
			local spell_bc = FourCC('ATbc')
			local lightnings = {}
			local timers_drain = {}
			local timers_effect = {}
			local timers_light = {}
			local timers_kill = {}
			local bc_effect_chain = "Abilities\\Spells\\Items\\AIil\\AIilTarget.mdl"
			local bc_effect_light = "Abilities\\Spells\\Other\\Charm\\CharmTarget.mdl"
			-- Ejection
			local spell_ej = FourCC('ATej')
			-- True Shape
			local spell_ts = FourCC('ATts')
			local spell_td = FourCC('ATd5')
			local ts_effect_slam = "Abilities\\Spells\\Undead\\UnholyFrenzyAOE\\UnholyFrenzyAOETarget.mdl"
			local ts_effect_chest = "Abilities\\Spells\\Orc\\FeralSpirit\\feralspiritdone.mdl"
			local ts_effect_fire = "CasterOfMana\\NetherInferno.mdx"
			-- Soulflayer
			local spell_sf = FourCC('ATsf')
			local spell_sd = FourCC('ATd2')
			local spell_s1 = FourCC('ATd7')
			local spell_s2 = FourCC('AT11')
			local move_timers = {}
			local spell_ow = FourCC('ATd3') -- Other World
			local spell_mw = FourCC('ATd4') -- Material World
			local sf_effect_create = "Abilities\\Spells\\NightElf\\Blink\\BlinkTarget.mdl"
			local sf_effect_target = "Abilities\\Spells\\NightElf\\Blink\\BlinkCaster.mdl"
			local sf_effect_dying = "Objects\\Spawnmodels\\Undead\\UndeadDissipate\\UndeadDissipate.mdl"
			
			-- Caster of Mana Heroes
			local hero_1 = FourCC('Tcom')
			-- local hero_2 = FourCC('Abcd') -- your hero id

			-- Spell Stats
			-- Mental Erosion
			local dmg_inc = {
				[1] = 1.30,
				[2] = 1.35,
				[3] = 1.40,
				[4] = 1.45,
				[5] = 1.50
			}	
			local hero_table = {
				[hero_1] = {
					-- Mental Erosion
					me_lvl = 0,
					me_range = {
						[1] = 200.0,
						[2] = 25.0
					},
					-- Burning Chains
					bc_timeout_drain = 1.0,
					bc_mana_drain = {
						[1] = 25.0,
						[2] = 30.0,
						[3] = 35.0,
						[4] = 40.0,
						[5] = 45.0
					},
					bc_lightnings = {},
					bc_timers_drain = {},
					bc_add_mana = {
						[1] = 5.0,
						[2] = 5.0,
						[3] = 5.0,
						[4] = 5.0,
						[5] = 5.0
					},
					-- Ejection
					ej_max_targets = {
						[1] = 3,
						[2] = 3,
						[3] = 3,
						[4] = 3,
						[5] = 3
					},
					-- True Shape
					-- ts_lvl = 0,
					ts_cooldown_dec = {
						[1] = 5.0,
						[2] = 6.0,
						[3] = 7.0
					},
					-- Soulflayer
					sf_lvl = 0,
					sf_max_souls = {
						[1] = 5,
						[2] = 5,
						[3] = 5,
						[4] = 5,
						[5] = 5
					},
					sf_int_inc = {
						[1] = 1,
						[2] = 2,
						[3] = 3,
						[4] = 4,
						[5] = 5
					},
					sf_state = 0,
					sf_units = {},
					sf_move_timers = {},
					sf_trigger_attack = nil
				}--,
				-- [hero_2] = {
					-- stats
				-- }
			}
			
			local function DummyCreate(player, x, y, ability_id, level)
				local dummy = CreateUnit(player, FourCC('dumy'), x, y, 0.0)
				UnitAddAbility(dummy, ability_id)
				SetUnitAbilityLevel(dummy, ability_id, level)
				UnitApplyTimedLife(dummy, FourCC('BTLF'), 5.0)
				return dummy
			end
			
			local function DummyCastTarget(target, dummy, order_id, tp)
				if tp then
					SetUnitX(dummy, GetUnitX(target))
					SetUnitY(dummy, GetUnitY(target))
				end
				local order = IssueTargetOrderById(dummy, order_id, target)
				return order
			end
			
			local function GroupEnemyUnitsInRange(x, y, radius, player)
				local group = CreateGroup()
				GroupEnumUnitsInRange(group, x, y, radius, nil)
				for i = BlzGroupGetSize(group) - 1, 0, -1 do
					local unit = BlzGroupUnitAt(group, i)
					if IsUnitAlly(unit, player)
						or GetUnitAbilityLevel(unit, FourCC('Aloc')) > 0
						or GetUnitState(unit, UNIT_STATE_LIFE) <= 0
					then
						GroupRemoveUnit(group, unit)
					end
				end
				return group
			end
			
			local function DummyCastRandomTarget(group, x, y, player, max_targets, ability_id_dummy, level, order_id)
				local size = BlzGroupGetSize(group)
				if size > 1 then
					for i = 1, max_targets do
						local random_index = math.random(0, size - 1)
						local target = BlzGroupUnitAt(group, random_index)
						local dummy = DummyCreate(player, x, y, ability_id_dummy, level)
						DummyCastTarget(target, dummy, order_id, nil)
					end
				end
				GroupClear(group)
			end
			
			local function MentalErosion(caster_owner, x, y, ability_id_dummy, level, caster, radius)
				local dummy = DummyCreate(caster_owner, x, y, ability_id_dummy, level)
				local dur_hero = BlzGetAbilityRealLevelField(BlzGetUnitAbility(caster, spell_me), ABILITY_RLF_DURATION_HERO, level - 1)
				local dur_normal = BlzGetAbilityRealLevelField(BlzGetUnitAbility(caster, spell_me), ABILITY_RLF_DURATION_NORMAL, level - 1)
				BlzSetAbilityRealLevelField(BlzGetUnitAbility(dummy, ability_id_dummy), ABILITY_RLF_DURATION_HERO, level - 1, dur_hero)
				BlzSetAbilityRealLevelField(BlzGetUnitAbility(dummy, ability_id_dummy), ABILITY_RLF_DURATION_NORMAL, level - 1, dur_normal)
				
				local group = CreateGroup()
				GroupEnumUnitsInRange(group, x, y, radius, nil)
				for i = BlzGroupGetSize(group) - 1, 0, -1 do
					local unit = BlzGroupUnitAt(group, i)
					if IsUnitAlly(unit, player)
						or GetUnitAbilityLevel(unit, FourCC('Aloc')) > 0
						or GetUnitState(unit, UNIT_STATE_LIFE) <= 0
						or GetUnitAbilityLevel(unit, FourCC('BHbn')) > 0
						or GetUnitAbilityLevel(unit, FourCC('Bpsh')) > 0
						or GetUnitTypeId(targets) == FourCC('ospm')
					then
						GroupRemoveUnit(group, unit)
					end
				end
				
				local size = BlzGroupGetSize(group)
				if size > 0 then
					for i = size - 1, 0, -1 do
						local target = BlzGroupUnitAt(group, i)
						DummyCastTarget(target, dummy, 852585, true) -- drunkenhaze
					end
				end
				GroupClear(group)
			end
			
			local function ManaDrain(target, caster_id, caster, level, dur_normal, dur_hero)
				if GetUnitAbilityLevel(target, FourCC('BTd2')) > 0 then
					DestroyLightning(lightnings[target])
					PauseTimer(timers_drain[target])
					DestroyTimer(timers_drain[target])
					PauseTimer(timers_light[target])
					DestroyTimer(timers_light[target])
					PauseTimer(timers_kill[target])
					DestroyTimer(timers_kill[target])
					PauseTimer(timers_effect[target])
					DestroyTimer(timers_effect[target])
				end
				
				timers_effect[target] = CreateTimer()
				TimerStart(timers_effect[target], hero_table[caster_id].bc_timeout_drain, true, function()
					DestroyEffect(AddSpecialEffectTarget(bc_effect_chain, target, "origin"))
				end)
			
				if (GetUnitState(target, UNIT_STATE_MAX_MANA) > 0.0)
					or (IsUnitType(target, UNIT_TYPE_HERO) and BlzGetUnitIntegerField(target, UNIT_IF_INTELLIGENCE) > 0)
				then
					lightnings[target] = AddLightningEx("DRAM", false, GetUnitX(target), GetUnitY(target), BlzGetUnitZ(target) + 50.0, GetUnitX(caster), GetUnitY(caster), BlzGetUnitZ(caster) + 50.0)
					table.insert(hero_table[caster_id].bc_lightnings, lightnings[target])
					timers_drain[target] = CreateTimer()
					table.insert(hero_table[caster_id].bc_timers_drain, timers_drain[target])
					
					TimerStart(timers_drain[target], hero_table[caster_id].bc_timeout_drain, true, function()
						if GetUnitState(caster, UNIT_STATE_MANA) < BlzGetUnitMaxMana(caster) 
							and GetUnitState(target, UNIT_STATE_MANA) > 0.0
						then
							local mana_drain = hero_table[caster_id].bc_mana_drain[level]
							if GetUnitAbilityLevel(target, FourCC('BTd1')) > 0 then
								mana_drain = hero_table[caster_id].bc_mana_drain[level] + hero_table[caster_id].bc_add_mana[level]
							end
							local mana = GetUnitState(target, UNIT_STATE_MANA)
							if mana >= mana_drain then							
								SetUnitState(target, UNIT_STATE_MANA, mana - mana_drain)
								SetUnitState(caster, UNIT_STATE_MANA, GetUnitState(caster, UNIT_STATE_MANA) + mana_drain)
							elseif mana < mana_drain then							
								SetUnitState(target, UNIT_STATE_MANA, mana - mana)
								SetUnitState(caster, UNIT_STATE_MANA, GetUnitState(caster, UNIT_STATE_MANA) + mana)
							end
						end
					end)
					
					timers_light[target] = CreateTimer()
					TimerStart(timers_light[target], 0.003125, true, function()
						if IsUnitInRange(target, caster, 650.0) then
							MoveLightningEx(lightnings[target], false, GetUnitX(target), GetUnitY(target), BlzGetUnitZ(target) + 50.0, GetUnitX(caster), GetUnitY(caster), BlzGetUnitZ(caster) + 50.0)
						else
							DestroyEffect(AddSpecialEffectTarget(bc_effect_light, caster, "chest"))
							DestroyLightning(lightnings[target])
							PauseTimer(timers_drain[target])
							DestroyTimer(timers_drain[target])
							PauseTimer(timers_light[target])
							DestroyTimer(timers_light[target])
						end
					end)
				end
				
				local timeoutkill = dur_normal
				if IsUnitType(target, UNIT_TYPE_HERO) then
					timeoutkill = dur_hero
				end
				timers_kill[target] = CreateTimer()
				TimerStart(timers_kill[target], timeoutkill, false, function()
					DestroyLightning(lightnings[target])
					PauseTimer(timers_drain[target])
					DestroyTimer(timers_drain[target])
					PauseTimer(timers_effect[target])
					DestroyTimer(timers_effect[target])
					PauseTimer(timers_light[target])
					DestroyTimer(timers_light[target])
					PauseTimer(timers_kill[target])
					DestroyTimer(timers_kill[target])
				end)
			end
			
			local function MoveCircle(unit, soul_counter, max_souls, caster)
				DestroyEffect(AddSpecialEffectTarget(sf_effect_create, unit, "origin"))
				local circle_offset = 200.0 -- the range from center to the unit should be
				local circle_degrees = soul_counter * (360.0 / max_souls) -- the amount of degrees the unit starts
				-- local circle_speed = 0.05 -- the angle speed (in degrees) at which the unit will be circling (negative to circle the other direction)
				local timer = CreateTimer()
				TimerStart(timer, 0.003125, true, function()
					local x = GetUnitX(caster) + circle_offset * math.cos(circle_degrees * 0.017453292)
					local y = GetUnitY(caster) + circle_offset * math.sin(circle_degrees * 0.017453292)
					SetUnitX(unit, x)
					SetUnitY(unit, y)
					SetUnitFacingTimed(unit, GetUnitFacing(caster), 0.1)
					-- circle_degrees = circle_degrees + circle_speed -- circling
				end)
				return timer
			end
			
			local function BurningChains(caster_owner, x, y, ability_id_dummy, level, caster, target, caster_id)
				local dummy = DummyCreate(caster_owner, x, y, ability_id_dummy, level)
				local dur_hero = BlzGetAbilityRealLevelField(BlzGetUnitAbility(caster, spell_bc), ABILITY_RLF_DURATION_HERO, level - 1)
				local dur_normal = BlzGetAbilityRealLevelField(BlzGetUnitAbility(caster, spell_bc), ABILITY_RLF_DURATION_NORMAL, level - 1)
				BlzSetAbilityRealLevelField(BlzGetUnitAbility(dummy, ability_id_dummy), ABILITY_RLF_DURATION_HERO, level - 1, dur_hero)
				BlzSetAbilityRealLevelField(BlzGetUnitAbility(dummy, ability_id_dummy), ABILITY_RLF_DURATION_NORMAL, level - 1, dur_normal)
				DummyCastTarget(target, dummy, 852106, true) -- ensnare
				ManaDrain(target, caster_id, caster, level, dur_normal, dur_hero)

				if #hero_table[caster_id].sf_units > 0 and hero_table[caster_id].sf_state == 0 then
					local random_index = math.random(#hero_table[caster_id].sf_units)
					local unit = hero_table[caster_id].sf_units[random_index]
					dummy = DummyCreate(caster_owner, GetUnitX(unit), GetUnitY(unit), FourCC('ATd8'), hero_table[caster_id].sf_lvl)
					DummyCastTarget(target, dummy, 852570, true) -- shadowsight
					dummy = DummyCreate(caster_owner, GetUnitX(unit), GetUnitY(unit), FourCC('ATd9'), hero_table[caster_id].sf_lvl)
					DummyCastTarget(target, dummy, 852095, nil) -- thunderbolt 
					UnitApplyTimedLife(unit, FourCC('BTLF'), 0.1)
					table.remove(hero_table[caster_id].sf_units, random_index)
					
					local lvl = hero_table[caster_id].sf_lvl
					SetUnitAbilityLevel(caster, spell_sd, #hero_table[caster_id].sf_units * hero_table[caster_id].sf_int_inc[lvl] + 1)
					for i = 1, #hero_table[caster_id].sf_move_timers do
						PauseTimer(hero_table[caster_id].sf_move_timers[i])
						DestroyTimer(hero_table[caster_id].sf_move_timers[i])
					end
					local max_lvl = #hero_table[caster_id].sf_max_souls
					local max_souls = hero_table[caster_id].sf_max_souls[max_lvl]
					for i = 1, #hero_table[caster_id].sf_units do
						unit = hero_table[caster_id].sf_units[i]
						move_timers[unit] = MoveCircle(unit, i - 1, max_souls, caster)
						table.insert(hero_table[caster_id].sf_move_timers, move_timers[unit])
					end
				end
			end
			
			local function Ejection(x, y, radius, caster_owner, caster_id, ability_id_dummy, level, caster)
				local group = GroupEnemyUnitsInRange(x, y, radius, player)
				local size = BlzGroupGetSize(group)
				DummyCastRandomTarget(group, x, y, caster_owner, hero_table[caster_id].ej_max_targets[level], ability_id_dummy, level, 852231) -- firebolt
				if #hero_table[caster_id].sf_units > 0 and hero_table[caster_id].sf_state == 0 then
					for i = 1, #hero_table[caster_id].sf_units do
						x = GetUnitX(hero_table[caster_id].sf_units[i])
						y = GetUnitY(hero_table[caster_id].sf_units[i])
						group = GroupEnemyUnitsInRange(x, y, radius, player)
						DummyCastRandomTarget(group, x, y, caster_owner, 1, spell_s1, level, 852231) -- firebolt
						if size > 1 then
							UnitApplyTimedLife(hero_table[caster_id].sf_units[i], FourCC('BTLF'), 0.1)
						end
					end
					if size > 1 then
						hero_table[caster_id].sf_units = {}
						level = hero_table[caster_id].sf_lvl
						SetUnitAbilityLevel(caster, spell_sd, #hero_table[caster_id].sf_units * hero_table[caster_id].sf_int_inc[level] + 1)
						for i = 1, #hero_table[caster_id].sf_move_timers do
							PauseTimer(hero_table[caster_id].sf_move_timers[i])
							DestroyTimer(hero_table[caster_id].sf_move_timers[i])
						end
					end
				end
			end
			
			local function TrueShape(caster_id, caster, ability_id_dummy, level, ability, caster_owner)
				if hero_table[caster_id].sf_state == 1 then
					UnitRemoveAbility(caster, FourCC('ATd4'))
					UnitAddAbility(caster, FourCC('ATd3'))
					hero_table[caster_id].sf_state = 0
					for i = 1, #hero_table[caster_id].sf_units do
						UnitRemoveAbility(hero_table[caster_id].sf_units[i], FourCC('Agho'))
						BlzSetUnitSkin(hero_table[caster_id].sf_units[i], FourCC('tdsf'))
						DestroyEffect(AddSpecialEffectTarget(sf_effect_create, hero_table[caster_id].sf_units[i], "origin"))
					end
				end
				
				BlzUnitDisableAbility(caster, FourCC('ATd3'), true, false)
				UnitAddAbility(caster, ability_id_dummy)
				SetUnitAbilityLevel(caster, ability_id_dummy, level)
				local weapon_type = BlzGetUnitWeaponIntegerField(caster, UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0)
				BlzSetUnitWeaponIntegerField(caster, UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0, 5)
				
				-- Mental Erosion
				local levelME = GetUnitAbilityLevel(caster, spell_me) - 1
				local cooldownME = BlzGetUnitAbilityCooldown(caster, spell_me, levelME)
				BlzSetUnitAbilityCooldown(caster, spell_me, levelME, cooldownME - hero_table[caster_id].ts_cooldown_dec[level])				
				-- Burning Chains
				local levelBC = GetUnitAbilityLevel(caster, spell_bc) - 1
				local cooldownBC = BlzGetUnitAbilityCooldown(caster, spell_bc, levelBC)
				BlzSetUnitAbilityCooldown(caster, spell_bc, levelBC, cooldownBC - hero_table[caster_id].ts_cooldown_dec[level])
				-- Ejection
				local levelEJ = GetUnitAbilityLevel(caster, spell_ej) - 1
				local cooldownEJ = BlzGetUnitAbilityCooldown(caster, spell_ej, levelEJ)
				BlzSetUnitAbilityCooldown(caster, spell_ej, levelEJ, cooldownEJ - hero_table[caster_id].ts_cooldown_dec[level])
				
				local timeout = BlzGetAbilityRealLevelField(ability, ABILITY_RLF_DURATION_NORMAL, level - 1)
				local cooldown = 0.0
				local timercd = CreateTimer()
				TimerStart(timercd, 1.0, true, function()
					cooldown = cooldown + 1.0
					BlzSetUnitAbilityCooldown(caster, spell_td, level - 1, timeout - cooldown)
				end)
				
				BlzSetUnitSkin(caster, FourCC('nTd1'))
				DestroyEffect(AddSpecialEffectTarget(ts_effect_slam, caster, "origin"))
				DestroyEffect(AddSpecialEffectTarget(ts_effect_chest, caster, "origin"))
				local effect = AddSpecialEffectTarget(ts_effect_fire, caster, "origin")
				
				if #hero_table[caster_id].sf_units > 0 then
					hero_table[caster_id].sf_trigger_attack = CreateTrigger()
					for i = 0, max_players do
						TriggerRegisterPlayerUnitEvent(hero_table[caster_id].sf_trigger_attack, Player(i), EVENT_PLAYER_UNIT_DAMAGED, nil)
					end
					TriggerAddAction(hero_table[caster_id].sf_trigger_attack, function()
						if GetEventDamageSource() == caster then
							for i = 1, #hero_table[caster_id].sf_units do
								SetUnitAnimation(hero_table[caster_id].sf_units[i], "spell")
								QueueUnitAnimation(hero_table[caster_id].sf_units[i], "stand")
								local dummy = DummyCreate(caster_owner, GetUnitX(hero_table[caster_id].sf_units[i]), GetUnitY(hero_table[caster_id].sf_units[i]), FourCC('AT10'), hero_table[caster_id].sf_lvl)
								DummyCastTarget(GetTriggerUnit(), dummy, 852231, nil) -- firebolt
							end
						end
					end)
				end
				
				local timer = CreateTimer()
				TimerStart(timer, timeout, false, function()
					DestroyTrigger(hero_table[caster_id].sf_trigger_attack)
				
					BlzSetUnitAbilityCooldown(caster, spell_me, levelME, cooldownME)
					BlzSetUnitAbilityCooldown(caster, spell_bc, levelBC, cooldownBC)
					BlzSetUnitAbilityCooldown(caster, spell_ej, levelEJ, cooldownEJ)
					
					BlzSetUnitSkin(caster, caster_id)
					DestroyEffect(AddSpecialEffectTarget(ts_effect_slam, caster, "origin"))
					DestroyEffect(AddSpecialEffectTarget(ts_effect_chest, caster, "origin"))
					DestroyEffect(effect)
					
					BlzSetUnitWeaponIntegerField(caster, UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0, weapon_type)
					UnitRemoveAbility(caster, ability_id_dummy)
					BlzUnitDisableAbility(caster, FourCC('ATd3'), false, false)
					
					PauseTimer(timercd)
					DestroyTimer(timercd)
					PauseTimer(timer)
					DestroyTimer(timer)
				end)
			end
			
			local function Soulflayer(caster, abilid1, abilid2, caster_id, ability_id_dummy, unit_skin, soul_state)
				UnitRemoveAbility(caster, abilid1)
				UnitAddAbility(caster, abilid2)
				hero_table[caster_id].sf_state = soul_state
				for i = 1, #hero_table[caster_id].sf_units do
					if soul_state == 1 then
						UnitAddAbility(hero_table[caster_id].sf_units[i], ability_id_dummy)
					else
						UnitRemoveAbility(hero_table[caster_id].sf_units[i], ability_id_dummy)
					end
					BlzSetUnitSkin(hero_table[caster_id].sf_units[i], unit_skin)
					DestroyEffect(AddSpecialEffectTarget(sf_effect_target, hero_table[caster_id].sf_units[i], "origin"))
				end
			end
			
			local function HeroLearnedSkill()
				local learning = CreateTrigger()
				for i = 0, max_players do 
					TriggerRegisterPlayerUnitEvent(learning, Player(i), EVENT_PLAYER_HERO_SKILL, nil)
				end
				TriggerAddAction(learning, function()
					local caster = GetLearningUnit()
					local caster_id = GetUnitTypeId(caster)
					local ability_id = GetLearnedSkill()
					local level = GetLearnedSkillLevel()
					
					if ability_id == spell_me then
						hero_table[caster_id].me_lvl = level
						
					-- elseif ability_id == spell_bc then
						-- hero_table[caster_id].bc_lvl = level
					
					elseif ability_id == spell_ej then
						if #hero_table[caster_id].sf_units > 0 then
							for i = 1, #hero_table[caster_id].sf_units do
								SetUnitAbilityLevel(hero_table[caster_id].sf_units[i], FourCC('ATd7'), hero_table[caster_id].sf_lvl)
							end
						end
						
					-- elseif ability_id == spell_ts then
						-- hero_table[caster_id].ts_lvl = level
						
					elseif ability_id == spell_sf then
						hero_table[caster_id].sf_lvl = level
						UnitAddAbility(caster, FourCC('ATd3'))
						UnitAddAbility(caster, spell_sd)
						if #hero_table[caster_id].sf_units > 0 then
							for i = 1, #hero_table[caster_id].sf_units do
								SetUnitAbilityLevel(hero_table[caster_id].sf_units[i], FourCC('AT10'), hero_table[caster_id].sf_lvl)
							end
						end
						if level > 1 then
							SetUnitAbilityLevel(caster, spell_sd, #hero_table[caster_id].sf_units * hero_table[caster_id].sf_int_inc[level] + 1)
						end
					end
						
					if GetUnitAbilityLevel(caster, spell_td) > 0 and (ability_id == spell_me or ability_id == spell_bc or ability_id == spell_ej) then
						local levelTS = GetUnitAbilityLevel(caster, spell_td)

						local cooldown = BlzGetUnitAbilityCooldown(caster, ability_id, level - 1)

						BlzSetUnitAbilityCooldown(caster, ability_id, level - 1, cooldown - hero_table[caster_id].ts_cooldown_dec[levelTS])				
						local newcooldown = BlzGetUnitAbilityCooldown(caster, ability_id, level - 1)

						local timer = CreateTimer()
						local timeout = BlzGetUnitAbilityCooldown(caster, spell_td, levelTS - 1)

						TimerStart(timer, timeout, false, function()
							BlzSetUnitAbilityCooldown(caster, ability_id, level - 1, cooldown)
							PauseTimer(timer)
							DestroyTimer(timer)
						end)
					end
				end)
			end
			
			local function UnitSpellEffect()
				local cast = CreateTrigger()
				for i = 0, max_players do
					TriggerRegisterPlayerUnitEvent(cast, Player(i), EVENT_PLAYER_UNIT_SPELL_EFFECT)
				end
				TriggerAddAction(cast, function()
					local caster = GetTriggerUnit()
					local caster_id = GetUnitTypeId(caster)
					local caster_owner = GetOwningPlayer(caster)
					local ability = GetSpellAbility()
					local ability_id = GetSpellAbilityId()
					local level = GetUnitAbilityLevel(caster, ability_id)
					local target = GetSpellTargetUnit()
					local x, y = GetSpellTargetX(), GetSpellTargetY()
					
					 -- Mental Erosion
					if ability_id == spell_me then
						local radius = BlzGetAbilityRealLevelField(ability, ABILITY_RLF_AREA_OF_EFFECT, level - 1)
						MentalErosion(caster_owner, x, y, spell_md, level, caster, radius)
											
					 -- Burning Chains
					elseif ability_id == spell_bc then
						BurningChains(caster_owner, x, y, FourCC('ATd6'), level, caster, target, caster_id)
					
					 -- Ejection
					elseif ability_id == spell_ej then
						x = GetUnitX(caster)
						y = GetUnitY(caster)
						local radius = BlzGetAbilityRealLevelField(ability, ABILITY_RLF_AREA_OF_EFFECT, level - 1)
						Ejection(x, y, radius, caster_owner, caster_id, spell_s2, level, caster)
						
					 -- True Shape
					elseif ability_id == spell_ts then
						TrueShape(caster_id, caster, spell_td, level, ability, caster_owner)
					
					 -- Other World
					elseif ability_id == spell_ow then
						Soulflayer(caster, FourCC('ATd3'), FourCC('ATd4'), caster_id, FourCC('Agho'), FourCC('nTd2'), 1)
					
					 -- Material World
					elseif ability_id == spell_mw then
						Soulflayer(caster, FourCC('ATd4'), FourCC('ATd3'), caster_id, FourCC('Agho'), FourCC('tdsf'), 0)
						
					end
				end)
			end

			local function UnitDying()
				local dying = CreateTrigger()
				for i = 0, max_players do 
					TriggerRegisterPlayerUnitEvent(dying, Player(i), EVENT_PLAYER_UNIT_DEATH, nil)
				end
				TriggerAddAction(dying, function()
					local caster = GetKillingUnit()
					local caster_id = GetUnitTypeId(caster)
					local caster_owner = GetOwningPlayer(caster)
					local dying_unit = GetDyingUnit()
					local dying_unit_id = GetUnitTypeId(dying_unit)
					local dying_unit_owner = GetOwningPlayer(dying_unit)
					
					-- Burning Chains
					DestroyLightning(lightnings[dying_unit])
					PauseTimer(timers_drain[dying_unit])
					DestroyTimer(timers_drain[dying_unit])
					PauseTimer(timers_effect[dying_unit])
					DestroyTimer(timers_effect[dying_unit])
					
					for k in pairs(hero_table) do
						if dying_unit_id == k then
							for i = 1, #hero_table[dying_unit_id].bc_lightnings do
								DestroyLightning(hero_table[dying_unit_id].bc_lightnings[i])
							end
							for i = 1, #hero_table[dying_unit_id].bc_timers_drain do
								PauseTimer(hero_table[dying_unit_id].bc_timers_drain[i])
								DestroyTimer(hero_table[dying_unit_id].bc_timers_drain[i])
							end
							if #hero_table[dying_unit_id].sf_units > 0 then
								for i = 1, #hero_table[dying_unit_id].sf_units do
									UnitApplyTimedLife(hero_table[dying_unit_id].sf_units[i], FourCC('BTLF'), 0.3)
									DestroyEffect(AddSpecialEffectTarget(sf_effect_dying, hero_table[dying_unit_id].sf_units[i], "origin"))
								end
								for i = 1, #hero_table[dying_unit_id].sf_move_timers do
									PauseTimer(hero_table[dying_unit_id].sf_move_timers[i])
									DestroyTimer(hero_table[dying_unit_id].sf_move_timers[i])
								end
								if hero_table[dying_unit_id].me_lvl > 0 and hero_table[dying_unit_id].sf_state == 0 then
									local x = GetUnitX(dying_unit)
									local y = GetUnitY(dying_unit)
									local level = hero_table[dying_unit_id].me_lvl
									local radius = hero_table[dying_unit_id].me_range[1] + hero_table[dying_unit_id].me_range[2] * hero_table[dying_unit_id].sf_lvl
									MentalErosion(dying_unit_owner, x, y, spell_md, level, dying_unit, radius)
									DestroyEffect(AddSpecialEffectTarget(me_effect_slam, dying_unit, "origin"))
								end
								hero_table[dying_unit_id].sf_units = {}
							end
						end
					end
					
					-- Soulflayer
					local level = GetUnitAbilityLevel(caster, spell_sf)
					local soul_counter = #hero_table[caster_id].sf_units
					local max_lvl = #hero_table[caster_id].sf_max_souls
					local max_souls = hero_table[caster_id].sf_max_souls[max_lvl]
					if GetUnitAbilityLevel(caster, spell_sf) > 0 
						and IsUnitType(dying_unit, UNIT_TYPE_STRUCTURE) == false
						and IsUnitType(dying_unit, UNIT_TYPE_SUMMONED) == false
						and IsUnitType(dying_unit, UNIT_TYPE_UNDEAD) == false
						and IsUnitType(dying_unit, UNIT_TYPE_MECHANICAL) == false
						and soul_counter < hero_table[caster_id].sf_max_souls[level]
					then	
						SetUnitAbilityLevel(caster, spell_sd, (soul_counter + 1) * hero_table[caster_id].sf_int_inc[level] + 1)
						DestroyEffect(AddSpecialEffectTarget("Abilities\\Spells\\Items\\AIso\\AIsoTarget.mdl", dying_unit, "origin"))
						DestroyEffect(AddSpecialEffectTarget("Abilities\\Spells\\NightElf\\Blink\\BlinkCaster.mdl", dying_unit, "origin"))
						
						local unit = BlzCreateUnitWithSkin(caster_owner, FourCC('tdsf'), GetUnitX(dying_unit), GetUnitY(dying_unit), GetUnitFacing(caster), FourCC('tdsf'))
						table.insert(hero_table[caster_id].sf_units, unit)
						
						move_timers[unit] = MoveCircle(unit, soul_counter, max_souls, caster)
						table.insert(hero_table[caster_id].sf_move_timers, move_timers[unit])
						
						if GetUnitAbilityLevel(caster, spell_ej) > 0 then
							SetUnitAbilityLevel(unit, FourCC('ATd7'), GetUnitAbilityLevel(caster, spell_ej))
						end
						if hero_table[caster_id].sf_state == 1 then
							UnitAddAbility(unit, FourCC('Agho'))
							BlzSetUnitSkin(unit, FourCC('ngh1'))
						end
					end
					
				end)
			end
			
			local function HeroRevivable()
				local revive = CreateTrigger()
				for i = 0, max_players do 
					TriggerRegisterPlayerUnitEvent(revive, Player(i), EVENT_PLAYER_HERO_REVIVABLE, nil)
				end
				TriggerAddAction(revive, function()
					local caster = GetRevivableUnit()
					local caster_id = GetUnitTypeId(caster)
					if GetUnitAbilityLevel(caster, spell_sf) > 0 then
						SetUnitAbilityLevel(caster, spell_sd, 1)
					end
				end)
			end
			
			local function UnitAttacked()			
				local attacked = CreateTrigger()
				for i = 0, max_players do 
					TriggerRegisterPlayerUnitEvent(attacked, Player(i), EVENT_PLAYER_UNIT_ATTACKED, nil)
				end
				TriggerAddAction(attacked, function()
					local attacktype = BlzGetUnitWeaponIntegerField(GetAttacker(), UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0)
					if GetUnitAbilityLevel(GetTriggerUnit(), spell_md) == 1
						and attacktype ~= 5 and attacktype ~= 4 and attacktype ~= 0
					then
						IssueImmediateOrder(GetAttacker(), "stop")
					end
				end)				
			end
			
			local function UnitDamaged()
				local damaged = CreateTrigger()
				for i = 0, max_players do 
					TriggerRegisterPlayerUnitEvent(damaged, Player(i), EVENT_PLAYER_UNIT_DAMAGED, nil)
				end
				TriggerAddAction(damaged, function()
					local attacktype = BlzGetEventAttackType()
					local damage = GetEventDamage()
					if (GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd1')) > 0 
						or GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd6')) > 0
						or GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd7')) > 0
						or GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd8')) > 0
						or GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd9')) > 0)
						and damage > 0.0 
					then
						local level = 1
						if GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd6')) > 0 then
							level = 2
						elseif GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd7')) > 0 then
							level = 3
						elseif GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd8')) > 0 then
							level = 4
						elseif GetUnitAbilityLevel(GetTriggerUnit(), FourCC('BTd9')) > 0 then
							level = 5
						end
						if attacktype == ATTACK_TYPE_CHAOS or attacktype == ATTACK_TYPE_MAGIC or attacktype == ATTACK_TYPE_NORMAL then
							BlzSetEventDamage(damage * dmg_inc[level])
						else 
							BlzSetEventDamage(0.0)
						end
					end					
				end)			
			end
				DisplayTimedTextToPlayer(GetLocalPlayer(), 0.0, 0.0, 2.0, "Loading...\n\nType -test to skip introducing\n\n")
				CinematicFilterGenericBJ(2.0, BLEND_MODE_BLEND, "ReplaceableTextures\\CameraMasks\\Black_mask.blp", 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0)
				ShowInterface(false, 0.1)
				EnableUserControl(false)
				-- loading
				DestroyEffect(AddSpecialEffectTarget(me_effect_slam, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(bc_effect_chain, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(ts_effect_chest, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(ts_effect_fire, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(ts_effect_slam, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(sf_effect_create, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(sf_effect_dying, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget(sf_effect_target, test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget("Abilities\\Spells\\Undead\\Possession\\PossessionMissile.mdl", test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget("Abilities\\Weapons\\ZigguratMissile\\ZigguratMissile.mdl", test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget("Abilities\\Weapons\\VoidWalkerMissile\\VoidWalkerMissile.mdl", test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget("Abilities\\Weapons\\FireballMissile\\FireballMissile.mdl", test_hero, "origin"))
				DestroyEffect(AddSpecialEffectTarget("Objects\\Spawnmodels\\Orc\\OrcSmallDeathExplode\\OrcSmallDeathExplode.mdl", test_hero, "origin"))
				RemoveUnit(CreateUnit(Player(0), FourCC('tdsf'), 0.0, 0.0, 0.0))
				RemoveUnit(CreateUnit(Player(0), FourCC('dumy'), 0.0, 0.0, 0.0))
				RemoveUnit(CreateUnit(Player(0), FourCC('nTd1'), 0.0, 0.0, 0.0))
				RemoveUnit(CreateUnit(Player(0), FourCC('nTd2'), 0.0, 0.0, 0.0))
				--
				EnableWeatherEffect(we, true)
				local d1 = CreateDestructable(FourCC('ATtr'), -3185.6, -3493.8, 25.0, 1.0, 1)
				local d2 = CreateDestructable(FourCC('ATtr'), -3379.3, -3618.5, 45.0, 0.9, 2)
				local d3 = CreateDestructable(FourCC('ATtr'), -3346.4, -3815.4, 120.0, 1.1, 3)
				local d4 = CreateDestructable(FourCC('ATtr'), -2863.5, -3910.2, 100.0, 0.85, 4)
				local d5 = CreateDestructable(FourCC('ATtr'), -2894.2, -4171.4, 270.0, 1.2, 5)
				local d6 = CreateDestructable(FourCC('ATtc'), -3122.4, -3714.9, 0.0, 1.1, 1)
				local d7 = CreateDestructable(FourCC('ATtc'), -3122.3, -3976.9, 155, 0.9, 2)
				local d8 = CreateDestructable(FourCC('ATtc'), -2637.1, -3976.9, 70.0, 1.0, 3)
				local u1 = BlzCreateUnitWithSkin(Player(22), FourCC("n00C"), -3401.0, -4776.5, 200.715, FourCC("n00C"))
				local u2 = BlzCreateUnitWithSkin(Player(22), FourCC("n00D"), -4490.6, -4099.6, 192.295, FourCC("n00D"))
				local u3 = BlzCreateUnitWithSkin(Player(22), FourCC("n00D"), -4608.9, -4322.6, 101.596, FourCC("n00D"))
				local u4 = BlzCreateUnitWithSkin(Player(22), FourCC("n00B"), -3432.9, -4084.5, 316.742, FourCC("n00B"))
				local b1 = BlzCreateUnitWithSkin(Player(22), FourCC("o000"), -4384.0, -3808.0, 270.000, FourCC("o000"))
				local b2 = BlzCreateUnitWithSkin(Player(22), FourCC("o001"), -4544.0, -5120.0, 70.000, FourCC("o001"))
				local b3 = BlzCreateUnitWithSkin(Player(22), FourCC("n003"), -4930.8, -4684.2, 27.399, FourCC("n003"))
				local b4 = BlzCreateUnitWithSkin(Player(22), FourCC("n004"), -3760.2, -5074.7, 90.974, FourCC("n004"))
				local b5 = BlzCreateUnitWithSkin(Player(22), FourCC("n003"), -3219.2, -5079.8, 161.360, FourCC("n003"))
				local b6 = BlzCreateUnitWithSkin(Player(22), FourCC("n003"), -4202.4, -3450.3, 226.790, FourCC("n003"))
				UnitRemoveAbility(u1, FourCC("Anh1"))
				UnitRemoveAbility(u1, FourCC("Anhe"))
				SetUnitInvulnerable(b1, true)
				SetUnitInvulnerable(b2, true)
				SetUnitInvulnerable(b3, true)
				SetUnitInvulnerable(b4, true)
				SetUnitInvulnerable(b5, true)
				SetUnitInvulnerable(b6, true)
				SetUnitState(u1, UNIT_STATE_LIFE, 50.0)
				SetUnitState(u2, UNIT_STATE_LIFE, 100.0)
				SetUnitState(u3, UNIT_STATE_LIFE, 100.0)
				SetUnitState(u4, UNIT_STATE_LIFE, 50.0)
				local s = CreateTimer()
				TimerStart(s, 2.0, false, function()
					DisplayCineFilter(false)
					PauseTimer(s)
					DestroyTimer(s)
				end)
				local start = CreateTimer()
				TimerStart(start, 5.0, false, function()
					PauseUnit(test_hero, true)
					PanCameraToTimed(-3276.13, -3988.00, 1.0)
					local camera = CreateTimer()
					TimerStart(camera, 1.0, false, function()
						PanCameraToTimed(-3276.13, -3988.00, 10.0)
						local k1 = CreateUnit(Player(1), FourCC('o003'), -2756.6, -3338.1, 236.54)
						local k2 = CreateUnit(Player(1), FourCC('o003'), -2476.6, -3548.4, 236.54)
						local f1 = CreateUnit(Player(22), FourCC('n00I'), -2756.6, -3338.1, 236.54)
						local f2 = CreateUnit(Player(11), FourCC('n00I'), -2476.6, -3548.4, 236.54)
						IssuePointOrder(k1, "attack", -3293.8, -3758.8)
						IssuePointOrder(k2, "attack", -2981.9, -4006.8)
						--SetUnitState(k1, UNIT_STATE_LIFE, 1.0)
						--SetUnitState(k2, UNIT_STATE_LIFE, 1.0)
						--
						KillDestructable(d1)
						KillDestructable(d2)
						KillDestructable(d3)
						KillDestructable(d4)
						KillDestructable(d5)
						KillDestructable(d6)
						KillDestructable(d7)
						KillDestructable(d8)
						IssuePointOrder(u1, "attack", -3293.8, -3758.8)
						IssuePointOrder(u2, "attack", -2981.9, -4006.8)
						IssuePointOrder(u3, "attack", -3293.8, -3758.8)
						--IssuePointOrder(u4, "attack", -2981.9, -4006.8)
						local go = CreateTimer()
						TimerStart(go, 10.0, false, function()
							PauseUnit(test_hero, false)
							PanCameraToTimed(GetUnitX(test_hero), GetUnitY(test_hero), 1.0)
							SetHeroLevel(test_hero, 6, false)
							SelectHeroSkill(test_hero, spell_me)
							SelectHeroSkill(test_hero, spell_bc)
							SelectHeroSkill(test_hero, spell_ej)
							SelectHeroSkill(test_hero, spell_ts)
							SelectHeroSkill(test_hero, spell_sf)
							-- CreateCommandButtonEffect(spell_me, "Tcom")
							UnitAddItemById(test_hero, FourCC('I000'))
							ShowInterface(true, 1.0)
							EnableUserControl(true)
							PauseTimer(go)
							DestroyTimer(go)
						end)
						PauseTimer(camera)
						DestroyTimer(camera)
					end)
					PauseTimer(start)
					DestroyTimer(start)
				end)
				
				local item = CreateTrigger()
				for i = 0, max_players do
					TriggerRegisterPlayerUnitEvent(item, Player(i), EVENT_PLAYER_UNIT_USE_ITEM, nil)
				end
				TriggerAddAction(item, function()
				
					BlzGetUnitWeaponIntegerField(GetTriggerUnit(), UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0)

					if FourCC('I000') == GetItemTypeId(GetManipulatedItem()) then
					
						RemoveItem(GetManipulatedItem())
						UnitAddItemById(GetTriggerUnit(), FourCC('I001'))
						BlzSetUnitWeaponIntegerField(GetTriggerUnit(), UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0, 6)
						BlzSetUnitWeaponRealField(GetTriggerUnit(), UNIT_WEAPON_RF_ATTACK_RANGE, 0, 100.0)
					
					elseif FourCC('I001') == GetItemTypeId(GetManipulatedItem()) then
					
						RemoveItem(GetManipulatedItem())
						UnitAddItemById(GetTriggerUnit(), FourCC('I000'))
						BlzSetUnitWeaponIntegerField(GetTriggerUnit(), UNIT_WEAPON_IF_ATTACK_ATTACK_TYPE, 0, 4)
						BlzSetUnitWeaponRealField(GetTriggerUnit(), UNIT_WEAPON_RF_ATTACK_RANGE, 0, 600.0)
					
					end
				end)
			end		
				local debugg = CreateTrigger()
				for i = 0, max_players do
					TriggerRegisterPlayerUnitEvent(debugg, Player(i), EVENT_PLAYER_UNIT_ISSUED_ORDER, nil)
					TriggerRegisterPlayerUnitEvent(debugg, Player(i), EVENT_PLAYER_UNIT_ISSUED_POINT_ORDER, nil)
					TriggerRegisterPlayerUnitEvent(debugg, Player(i), EVENT_PLAYER_UNIT_ISSUED_TARGET_ORDER, nil)
				end
				TriggerAddAction(debugg, function()
					--print(GetIssuedOrderId())
				end)
				
				local chated = CreateTrigger()
				for i = 0, max_players do
					TriggerRegisterPlayerChatEvent(chated, Player(i), "", false)
				end
				TriggerAddAction(chated, function()
					local chatstring = GetEventPlayerChatString()
					
					if SubString(chatstring, 0, 10) == "-control p" then
						local i = SubString(chatstring, 11, StringLength(chatstring))
						if i == "all" then
							for i = 0, max_players do
								SetPlayerAllianceStateBJ(Player(i), GetTriggerPlayer(), bj_ALLIANCE_ALLIED_ADVUNITS)
							end
						elseif i == "1"
								or i == "2"
								or i == "3"
								or i == "4"
								or i == "5"
								or i == "6"
								or i == "7"
								or i == "8"
								or i == "9"
								or i == "10"
								or i == "11"
								or i == "12"
						then
							i = S2I(i)
							if i >= 1 and i <= 12 then
								SetPlayerAllianceStateBJ(Player(i - 1), GetTriggerPlayer(), bj_ALLIANCE_ALLIED_ADVUNITS)
							end	
						end
					elseif SubString(chatstring, 0, 5) == "-test" then
						EnableWeatherEffect(we, false)
						SetHeroLevel(test_hero, 30, false)
						for i = 1, 5 do
							BlzSetUnitAbilityCooldown(test_hero, spell_me, i, 1.0)
							BlzSetUnitAbilityCooldown(test_hero, spell_bc, i, 1.0)
							BlzSetUnitAbilityCooldown(test_hero, spell_ej, i, 1.0)
							BlzSetUnitAbilityCooldown(test_hero, spell_ts, i, 1.0)
							BlzSetUnitAbilityCooldown(test_hero, spell_sf, i, 30.0)
						end
						UnitAddItemById(test_hero, FourCC('mnst'))
						FogMaskEnable(false)
						FogEnable(false)
						DisplayCineFilter(false)
						SetUnitPosition(test_hero, 0.0, 0.0)
						SetPlayerState(Player(10), PLAYER_STATE_RESOURCE_GOLD, 999999)
						SetPlayerState(Player(10), PLAYER_STATE_RESOURCE_LUMBER, 999999)
						SetPlayerState(Player(10), PLAYER_STATE_RESOURCE_FOOD_CAP, 300)
						PanCameraTo(GetUnitX(test_hero), GetUnitY(test_hero))
					end
				end)
			end

			local function Init()
				HeroLearnedSkill()			
				UnitSpellEffect()
				UnitDying()
				HeroRevivable()
				UnitDamaged()
				-- UnitAttacked() -- prevent attack to unit with Mental Erosion buff
			end
			
			Init()

		end)
		-- print("Status:", status) -- print errors
		-- print("Return Value: ", err)

	end
end
